package  {
	
	import flash.net.URLRequestMethod;
	import maggie.Audio;
	import maggie.Maggie;
	import maggie.TextLabel;
	
	public class Demo extends Maggie {
		
		private var vidas:uint        = 3;
		private var puntos:uint       = 0;
		private var puntaje:TextLabel = null;
		private var vida:TextLabel    = null;
		private var nave:Nave         = null;
		private var sonido:Audio      = null;
		
		public function Demo() {
			super(0);
			
			loadFont(Fuentes.EXCELATE);
			playMusic(Sonidos.MUSICA);
			
			this.nave = new Nave(10, (getScreenHeight() / 2), Imagenes.NAVE_NORMAL, this);
			
			this.puntaje = addText(10, 6,  "Puntos: 0", 0, "Excelate", 10);
			this.vida    = addText(10, 26, "Vidas: 3",  0, "Excelate", 10);
			
			setBackGroundImage(Imagenes.CIELO);
			crearEnemigo(10);
		}
		
		public function ejecutarSonido():void {
			if (sonido == null)
				sonido = playAudio(Sonidos.HELICOPTERO, true);
			else if (!sonido.isPlaying())
				sonido.play();
		}
		
		public function detenerSonido():void {
			if (!existsType(Enemigo))
				sonido.stop();
		}
		
		public function sumarPuntos(valor:uint):void {
			this.puntos += valor;
			this.puntaje.setText("Puntos: " + this.puntos);
		}
		
		public function quitarVida():void {
			this.vidas--;
			this.vida.setText("Vidas: " + this.vidas);
		}
		
		public function getVidas():uint {
			return this.vidas;
		}
		
		public function terminarJuego():void {
			this.puntaje.remove();
			this.vida.remove();
			
			this.puntaje = addText(0, getScreenHeight()/3, "GAME OVER", "0xFF0000", "Excelate", 55, true, true);
			this.vida    = addText(0, getScreenHeight()/2, "Puntos: " + this.puntos, "0x008000", "Excelate", 35, true, true);
		}
		
		public function crearEnemigo(cantidad:uint = 1):void {
			for (var i:uint = 0; i < cantidad; i++)
				var enemigo:Enemigo = new Enemigo(random(getScreenWidth(), (getScreenWidth() * 2)), random(10, getScreenHeight() - 50), Imagenes.ENEMIGO1, nave, this);
		}
	}
}