package {
	
	import maggie.Process;
	
	public class Rayo extends Process {
		
		private var demo:Demo = null;
		private var nave:Nave = null;
		
		public function Rayo(x:int, y:int, image:Class, demo:Demo, nave:Nave) {
			super(25, x, y, image);
			
			setAngle(getAngleWith(nave));
			
			this.nave = nave;
			this.demo = demo;
		}
		
		public override function run():void {
			advance(10);
			
			if (collisionWith(nave)) {
				nave.eliminar();
				finish();
				return;
			}
			
			if ((getX() < -getWidth()) || (getY() < -getHeight()) || (getY() > (getScreenHeight() + getHeight()))) { 
				finish();
				return;
			}
		}
	}
}